"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mustResolveWithin = exports.fail = exports.pass = void 0;

var pass = function pass(after) {
  var arg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "timeout";
  return new Promise(function (res, rej) {
    return setTimeout(res, after, arg);
  });
};

exports.pass = pass;

var fail = function fail(after) {
  var arg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "timeout";
  return new Promise(function (res, rej) {
    return setTimeout(rej, after, arg);
  });
};

exports.fail = fail;

var mustResolveWithin = function mustResolveWithin(promise, timespan) {
  return timespan >= 0 ? Promise.race([promise, fail(timespan)]) : promise;
};

exports.mustResolveWithin = mustResolveWithin;