/** @license @react-formilicious/core v2.0.0
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectSpread7 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var React = _interopRequireWildcard(require("react"));

var _find = _interopRequireDefault(require("./helpers/find"));

var _makePromise = _interopRequireDefault(require("./helpers/makePromise"));

var _sanitization = require("./logic/validators/sanitization");

var _ValidationResult = _interopRequireDefault(require("./validators/ValidationResult"));

var _timeout = require("./helpers/timeout");

var _defaultButtons = _interopRequireDefault(require("./defaultButtons"));

var _validation = require("./logic/validators/validation");

var _filterObject = _interopRequireWildcard(require("./helpers/filterObject"));

var renderButtonDefault = function renderButtonDefault(_ref) {
  var key = _ref.key,
      name = _ref.name,
      action = _ref.action,
      type = _ref.type,
      waiting = _ref.waiting;
  return React.createElement("button", {
    key: key,
    disabled: waiting,
    style: {
      margin: 2,
      border: "1px solid " + type
    },
    onClick: action
  }, name);
};

var renderFormDefault = function renderFormDefault(_ref2) {
  var elements = _ref2.elements,
      buttons = _ref2.buttons,
      validation = _ref2.validation;
  return React.createElement("form", {
    "data-react-formilicious": true
  }, elements, React.createElement("div", null, buttons, validation));
};

var Form =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(Form, _React$Component);

  function Form() {
    var _this;

    (0, _classCallCheck2.default)(this, Form);
    // todo: add a prop to validate the initial values.
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Form).call(this));

    _this.mounted = function (v) {
      if (v !== undefined) {
        _this.mounted.v = v;
      }

      return _this.mounted.v || false;
    };

    _this.state = {
      waiting: false,
      formValidationResult: null,
      fields: {},
      initialData: {}
    };
    _this.renderElement = _this.renderElement.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    _this.renderButton = _this.renderButton.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    _this.onSubmit = _this.onSubmitButtonClick.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    _this.onChange = _this.onChange.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    _this.onSubmitButtonClick = _this.onSubmitButtonClick.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    _this.onResetButtonClick = _this.onResetButtonClick.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    _this.onChangeField = _this.onChangeField.bind((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)));
    return _this;
  }

  (0, _createClass2.default)(Form, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mounted(true);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted(false);
    }
  }, {
    key: "setStatePromise",
    value: function setStatePromise(update) {
      var _this2 = this;

      return new Promise(function (res, rej) {
        var error;
        var changed;

        if (_this2.mounted()) {
          _this2.setState(function (s) {
            try {
              changed = typeof update === "function" ? update(s) : update;
              error = null;
            } catch (e) {
              changed = null;
              error = e;
            }

            return changed;
          }, function () {
            if (error) {
              rej(error);
            } else {
              res(changed);
            }
          });
        } else {
          rej("unmounted");
        }
      });
    }
  }, {
    key: "getSystemProps",
    value: function getSystemProps() {
      var _this$state = this.state,
          initialData = _this$state.initialData,
          fields = _this$state.fields,
          waiting = _this$state.waiting;
      return {
        initialData: initialData,
        fields: fields,
        waiting: waiting
      };
    }
  }, {
    key: "getFieldProps",
    value: function getFieldProps(key) {
      var field = this.state.fields[key];
      return (0, _objectSpread7.default)({}, field, {
        key: key,
        initialValue: this.state.initialData[key]
      });
    }
  }, {
    key: "getFieldValue",
    value: function getFieldValue(key) {
      var field = this.state.fields[key];
      if (field && field.value !== undefined) return field.value;
      var element = this.getElement(key);

      if (!element.ignoreData) {
        var initialValue = this.props.data[key] || this.state.initialData[key];
        if (initialValue !== undefined) return initialValue;
      }

      return element.type.getDefaultValue();
    }
  }, {
    key: "putFieldValue",
    value: function putFieldValue(key, values) {
      var _this3 = this;

      values = (0, _filterObject.default)(values, _filterObject.isNotUndefined);
      return this.setStatePromise(function (s) {
        return {
          fields: (0, _objectSpread7.default)({}, s.fields, (0, _defineProperty2.default)({}, key, s.fields[key] ? (0, _objectSpread7.default)({}, s.fields[key], values) : values))
        };
      }).then(function () {
        return _this3.state.fields[key];
      });
    }
  }, {
    key: "getElement",
    value: function getElement(key) {
      return this.props.elements.find(function (element) {
        return element.key === key;
      });
    }
  }, {
    key: "getFlatDataStructure",
    value: function getFlatDataStructure() {
      var _this4 = this;

      var elements = this.props.elements;
      return elements.reduce(function (acc, element) {
        return (0, _objectSpread7.default)({}, acc, (0, _defineProperty2.default)({}, element.key, _this4.getFieldValue(element.key)));
      }, {});
    }
  }, {
    key: "onChange",
    value: function onChange() {
      var onChange = this.props.onChange;

      if (onChange) {
        onChange(this.getFlatDataStructure());
      }
    }
  }, {
    key: "getFieldVersion",
    value: function getFieldVersion(key) {
      return this.state.fields[key] && this.state.fields[key].version || 0;
    }
  }, {
    key: "fieldMustBeVersion",
    value: function fieldMustBeVersion(key, version) {
      var willThrow = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      if (version !== this.getFieldVersion(key)) {
        if (willThrow) {
          throw "version-mismatch";
        }

        return false;
      }

      return true;
    }
  }, {
    key: "onChangeField",
    value: function () {
      var _onChangeField = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(key, value) {
        var _this5 = this;

        var _this$props$fieldTime, fieldTimeout, element, field, errorS;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!this.state.waiting) {
                  _context2.next = 3;
                  break;
                }

                console.warn("[react-formilicious]", "Tried to update field \"" + key + "\" with the following value while form was in waiting state.", value);
                return _context2.abrupt("return");

              case 3:
                _this$props$fieldTime = this.props.fieldTimeout, fieldTimeout = _this$props$fieldTime === void 0 ? 3000 : _this$props$fieldTime;
                element = this.getElement(key);
                _context2.next = 7;
                return this.putFieldValue(key, {
                  version: this.getFieldVersion(key) + 1,
                  value: value
                });

              case 7:
                field = _context2.sent;
                _context2.prev = 8;
                _context2.next = 11;
                return (0, _timeout.mustResolveWithin)((0, _asyncToGenerator2.default)(
                /*#__PURE__*/
                _regenerator.default.mark(function _callee() {
                  var validation;
                  return _regenerator.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          // First set the field to pending, then let's start the work.
                          _this5.fieldMustBeVersion(key, field.version);

                          _context.next = 3;
                          return _this5.putFieldValue(key, {
                            validated: "pending",
                            message: null
                          });

                        case 3:
                          _context.next = 5;
                          return (0, _validation.runValidator)(element.validator, value, _this5.getFlatDataStructure());

                        case 5:
                          validation = _context.sent;

                          // Once we have validated put the result into the field.
                          _this5.fieldMustBeVersion(key, field.version);

                          _context.next = 9;
                          return _this5.putFieldValue(key, {
                            validated: validation.validated,
                            message: validation.message
                          });

                        case 9:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee, this);
                }))(), fieldTimeout);

              case 11:
                // Fire the onChange event
                if (this.fieldMustBeVersion(key, field.version, false)) {
                  this.onChange();
                }

                ;
                _context2.next = 22;
                break;

              case 15:
                _context2.prev = 15;
                _context2.t0 = _context2["catch"](8);
                // If at any point a promise gets rejected, count the validation as failed.
                console.error("Field error", _context2.t0);

                if (!this.fieldMustBeVersion(key, field.version, false)) {
                  _context2.next = 22;
                  break;
                }

                errorS = (0, _sanitization.sanitizeValidationResult)(_context2.t0, true);
                _context2.next = 22;
                return this.putFieldValue(key, {
                  validated: errorS.validated,
                  message: errorS.message,
                  value: value
                });

              case 22:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[8, 15]]);
      }));

      return function onChangeField(_x, _x2) {
        return _onChangeField.apply(this, arguments);
      };
    }()
  }, {
    key: "revalidateElement",
    value: function () {
      var _revalidateElement = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee3(element) {
        var formData,
            key,
            validation,
            _this$props$fieldTime2,
            fieldTimeout,
            _args3 = arguments;

        return _regenerator.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                formData = _args3.length > 1 && _args3[1] !== undefined ? _args3[1] : this.getFlatDataStructure();
                key = element.key;
                _context3.next = 4;
                return this.putFieldValue(key, {
                  validated: "pending",
                  message: null
                });

              case 4:
                _this$props$fieldTime2 = this.props.fieldTimeout, fieldTimeout = _this$props$fieldTime2 === void 0 ? 3000 : _this$props$fieldTime2;
                _context3.prev = 5;
                _context3.next = 8;
                return (0, _timeout.mustResolveWithin)((0, _validation.runValidator)(element.validator, this.getFieldValue(key), formData), fieldTimeout);

              case 8:
                validation = _context3.sent;
                _context3.next = 14;
                break;

              case 11:
                _context3.prev = 11;
                _context3.t0 = _context3["catch"](5);
                validation = (0, _sanitization.sanitizeValidationResult)(_context3.t0, true);

              case 14:
                _context3.next = 16;
                return this.putFieldValue(key, {
                  validated: validation.validated,
                  message: validation.message
                });

              case 16:
                return _context3.abrupt("return", validation);

              case 17:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[5, 11]]);
      }));

      return function revalidateElement(_x3) {
        return _revalidateElement.apply(this, arguments);
      };
    }()
  }, {
    key: "revalidateElements",
    value: function revalidateElements(elements) {
      var _this6 = this;

      var formData = this.getFlatDataStructure();
      var all = elements.map(function (element) {
        return _this6.revalidateElement(element, formData);
      });
      return Promise.all(all);
    }
  }, {
    key: "onResetButtonClick",
    value: function onResetButtonClick(e) {
      e.preventDefault();

      if (!this.isFormReady()) {
        console.warn("[react-formilicious]", "Tried to reset form while form was in waiting state, or a field still pending.");
        return;
      }

      this.setState({
        fields: {},
        formValidationResult: null
      });
    }
  }, {
    key: "onSubmitButtonClick",
    value: function () {
      var _onSubmitButtonClick = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee4(e) {
        var _this$props, elements, _this$props$validateB, validateBeforeSubmit, res;

        return _regenerator.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                e.preventDefault(); // Cannot submit a form that is waiting. (waiting state is true, or a field is pending)

                if (this.isFormReady()) {
                  _context4.next = 4;
                  break;
                }

                console.warn("[react-formilicious]", "Tried to submit form while form was in waiting state, or a field still pending.");
                return _context4.abrupt("return");

              case 4:
                _context4.next = 6;
                return this.setStatePromise({
                  waiting: true
                });

              case 6:
                // Validate the form if desired.
                _this$props = this.props, elements = _this$props.elements, _this$props$validateB = _this$props.validateBeforeSubmit, validateBeforeSubmit = _this$props$validateB === void 0 ? true : _this$props$validateB;

                if (!validateBeforeSubmit) {
                  _context4.next = 10;
                  break;
                }

                _context4.next = 10;
                return this.revalidateElements(elements);

              case 10:
                _context4.prev = 10;
                _context4.next = 13;
                return this.submitForm();

              case 13:
                res = _context4.sent;
                console.log("[react-formilicious]", "Form submit!", res);
                _context4.next = 20;
                break;

              case 17:
                _context4.prev = 17;
                _context4.t0 = _context4["catch"](10);
                console.error("[react-formilicious]", "Form submit error!", _context4.t0);

              case 20:
                _context4.next = 22;
                return this.setStatePromise({
                  waiting: false
                });

              case 22:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this, [[10, 17]]);
      }));

      return function onSubmitButtonClick(_x4) {
        return _onSubmitButtonClick.apply(this, arguments);
      };
    }()
  }, {
    key: "isFormReady",
    value: function isFormReady() {
      var _this$state2 = this.state,
          waiting = _this$state2.waiting,
          fields = _this$state2.fields;
      return !waiting && !(0, _find.default)(fields, function (field) {
        return field.validated === "pending";
      });
    }
  }, {
    key: "findFormError",
    value: function findFormError() {
      var fields = this.state.fields;
      return (0, _find.default)(fields, function (field) {
        return field.validated === "error" || field.validated === "pending";
      });
    }
  }, {
    key: "submitForm",
    value: function () {
      var _submitForm = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee5() {
        var _this7 = this;

        var invalidField, onSubmit, data, validation, result, error;
        return _regenerator.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                invalidField = this.findFormError();

                if (!invalidField) {
                  _context5.next = 3;
                  break;
                }

                throw invalidField;

              case 3:
                _context5.next = 5;
                return this.setStatePromise({
                  formValidationResult: null
                });

              case 5:
                onSubmit = this.props.onSubmit;
                data = this.getFlatDataStructure();
                _context5.prev = 7;
                _context5.next = 10;
                return (0, _makePromise.default)(function () {
                  return onSubmit(data);
                });

              case 10:
                result = _context5.sent;
                validation = (0, _sanitization.sanitizeOnSubmitResult)(result);
                _context5.next = 17;
                break;

              case 14:
                _context5.prev = 14;
                _context5.t0 = _context5["catch"](7);
                validation = (0, _sanitization.sanitizeOnSubmitResult)(_context5.t0, true);

              case 17:
                _context5.next = 19;
                return Promise.all(validation.map(function (single) {
                  var key = single.key,
                      result = (0, _objectWithoutProperties2.default)(single, ["key"]);

                  if (!key || !_this7.getElement(key)) {
                    return _this7.setStatePromise({
                      formValidationResult: result
                    });
                  } else {
                    return _this7.putFieldValue(key, result);
                  }
                }));

              case 19:
                error = (0, _find.default)(validation, function (single) {
                  return single.validated === "error";
                });

                if (!error) {
                  _context5.next = 22;
                  break;
                }

                throw error;

              case 22:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this, [[7, 14]]);
      }));

      return function submitForm() {
        return _submitForm.apply(this, arguments);
      };
    }()
  }, {
    key: "render",
    value: function render() {
      return this.renderForm();
    }
  }, {
    key: "renderForm",
    value: function renderForm() {
      var formValidationResult = this.state.formValidationResult;
      return (this.props.renderForm || renderFormDefault)({
        elements: this.renderElements(),
        buttons: this.renderButtons(),
        validation: React.createElement(_ValidationResult.default, formValidationResult)
      });
    }
  }, {
    key: "renderButtons",
    value: function renderButtons() {
      var _this$props$buttons = this.props.buttons,
          buttons = _this$props$buttons === void 0 ? (0, _defaultButtons.default)() : _this$props$buttons;
      return buttons.map(this.renderButton);
    }
  }, {
    key: "renderButton",
    value: function renderButton(_ref4) {
      var _this8 = this;

      var key = _ref4.key,
          name = _ref4.name,
          action = _ref4.action,
          type = _ref4.type;
      var actionFn;

      switch (action) {
        case "submit":
          actionFn = this.onSubmitButtonClick;
          break;

        case "reset":
          actionFn = this.onResetButtonClick;
          break;

        default:
          actionFn = function actionFn(event) {
            return action(_this8.getFlatDataStructure(), event);
          };

          break;
      }

      var isReady = this.isFormReady();
      return (this.props.renderButton || renderButtonDefault)({
        key: key,
        name: name,
        type: type,
        action: actionFn,
        waiting: !isReady
      });
    }
  }, {
    key: "renderElements",
    value: function renderElements() {
      var elements = this.props.elements;
      return elements.map(this.renderElement);
    }
  }, {
    key: "renderElement",
    value: function renderElement(_ref5) {
      var _this9 = this;

      var FieldType = _ref5.type,
          key = _ref5.key,
          element = (0, _objectWithoutProperties2.default)(_ref5, ["type", "key"]);
      var onChange = this.onChangeField["handler/" + key];

      if (!onChange) {
        onChange = function onChange(rawValue) {
          return _this9.onChangeField(key, rawValue);
        };

        this.onChangeField["handler/" + key] = onChange;
      }

      return React.createElement(FieldType, (0, _extends2.default)({}, element, {
        key: key,
        system: this.getSystemProps(),
        field: this.getFieldProps(key),
        value: this.getFieldValue(key),
        onChange: onChange
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(newProps, oldState) {
      // todo: some elements may change completely, requiring us to remove their validation result
      var elements = newProps.elements,
          data = newProps.data;
      var initialData = elements.reduce(function (acc, element) {
        if (oldState.initialData[element.key] !== undefined) {
          return (0, _objectSpread7.default)({}, acc, (0, _defineProperty2.default)({}, element.key, oldState.initialData[element.key]));
        } else if (data[element.key] !== undefined) {
          return (0, _objectSpread7.default)({}, acc, (0, _defineProperty2.default)({}, element.key, data[element.key]));
        } else {
          return (0, _objectSpread7.default)({}, acc, (0, _defineProperty2.default)({}, element.key, element.type.getDefaultValue()));
        }
      }, {});
      return (0, _objectSpread7.default)({}, oldState, {
        initialData: initialData
      });
    }
  }]);
  return Form;
}(React.Component);

exports.default = Form;