"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextArea = exports.Input = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var React = _interopRequireWildcard(require("react"));

var ReactDOM = _interopRequireWildcard(require("react-dom"));

/**
 * This special type of input retains the cursor position over value changes. 
 * It behaves like a normal input.
 */
var Input =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inherits2.default)(Input, _React$PureComponent);

  function Input() {
    (0, _classCallCheck2.default)(this, Input);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Input).apply(this, arguments));
  }

  (0, _createClass2.default)(Input, [{
    key: "render",
    value: function render() {
      return React.createElement("input", (0, _extends2.default)({}, this.props, {
        value: undefined
      }));
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var node = ReactDOM.findDOMNode(this);

      if (node.type === "text") {
        node.value = this.props.value;
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var node = ReactDOM.findDOMNode(this); // Chrome Bug: Only text inputs can change selection

      if (node.type === "text") {
        var oldLength = node.value.length;
        var oldIdx = node.selectionStart;
        node.value = this.props.value;
        var newIdx = Math.max(0, node.value.length - oldLength + oldIdx);
        node.selectionStart = node.selectionEnd = newIdx;
      }
    }
  }]);
  return Input;
}(React.PureComponent);
/**
 * This special type of input retains the cursor position over value changes. 
 * It behaves like a normal input.
 */


exports.Input = Input;

var TextArea =
/*#__PURE__*/
function (_React$PureComponent2) {
  (0, _inherits2.default)(TextArea, _React$PureComponent2);

  function TextArea() {
    (0, _classCallCheck2.default)(this, TextArea);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(TextArea).apply(this, arguments));
  }

  (0, _createClass2.default)(TextArea, [{
    key: "render",
    value: function render() {
      return React.createElement("textarea", (0, _extends2.default)({}, this.props, {
        value: undefined
      }));
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var node = ReactDOM.findDOMNode(this);
      node.value = this.props.value;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var node = ReactDOM.findDOMNode(this);
      var oldLength = node.value.length;
      var oldIdx = node.selectionStart;
      node.value = this.props.value;
      var newIdx = Math.max(0, node.value.length - oldLength + oldIdx);
      node.selectionStart = node.selectionEnd = newIdx;
    }
  }]);
  return TextArea;
}(React.PureComponent);

exports.TextArea = TextArea;