"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runValidator = void 0;

var _makePromise = _interopRequireDefault(require("../../helpers/makePromise"));

var _sanitization = require("./sanitization");

/**
 * Runs the validator on the given value.
 * This promise never fails. We promise!
 */
var runValidator = function runValidator(validator, value) {
  for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    args[_key - 2] = arguments[_key];
  }

  var promise = (0, _makePromise.default)(function () {
    return validator ? validator.apply(void 0, [value].concat(args)) : {
      validated: "ok",
      message: null
    };
  });
  return promise.then(_sanitization.sanitizeValidationResult).catch(function (res) {
    return (0, _sanitization.sanitizeValidationResult)(res, true);
  });
};

exports.runValidator = runValidator;