"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.text = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var React = _interopRequireWildcard(require("react"));

var text = {
  pending: "⏳ Please wait ⌛",
  timeout: "⏱️ This field took longer to validate than expected. Please try again... ⏱",
  invalid: "Invalid value"
};
exports.text = text;

var ValidationResult =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inherits2.default)(ValidationResult, _React$PureComponent);

  function ValidationResult() {
    var _this;

    (0, _classCallCheck2.default)(this, ValidationResult);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(ValidationResult).call(this));
    _this.mounted = false;
    _this.state = {
      version: 0,
      validated: "ok",
      message: null
    };
    return _this;
  }

  (0, _createClass2.default)(ValidationResult, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.mounted = true;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.mounted = false;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prev) {
      var _this2 = this;

      var _this$props = this.props,
          validated = _this$props.validated,
          message = _this$props.message;

      if (prev.validated === validated && prev.message === message) {
        return;
      }

      var version = this.state.version + 1;

      if (validated === "pending" && prev.validated !== "pending") {
        this.setState({
          version: version
        }, function () {
          return setTimeout(function () {
            return _this2.mounted && _this2.setState(function (s) {
              return s.version === version ? {
                validated: validated,
                message: message
              } : null;
            });
          }, 100);
        });
      } else if (validated !== "pending" && prev.validated === "pending") {
        this.setState({
          version: version
        }, function () {
          return setTimeout(function () {
            return _this2.mounted && _this2.setState(function (s) {
              return s.version === version ? {
                validated: validated,
                message: message
              } : null;
            });
          }, 100);
        });
      } else {
        this.setState({
          version: version,
          validated: validated,
          message: message
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          validated = _this$state.validated,
          message = _this$state.message;

      switch (validated) {
        case "pending":
          return React.createElement("span", {
            className: "help"
          }, text.pending);

        case "error":
          return React.createElement("span", {
            className: "help is-danger"
          }, this.errorMessageOf(message));

        case "hint":
          return message && React.createElement("span", {
            className: "help is-info"
          }, message);

        default:
          return null;
      }
    }
  }, {
    key: "errorMessageOf",
    value: function errorMessageOf(message) {
      if (!message) return text.invalid;
      if (message === "timeout") return text.timeout;
      return message;
    }
  }]);
  return ValidationResult;
}(React.PureComponent);

exports.default = ValidationResult;