"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _sanitization = require("../logic/validators/sanitization");

var _makePromise = _interopRequireDefault(require("../helpers/makePromise"));

var combined = function combined() {
  for (var _len = arguments.length, all = new Array(_len), _key = 0; _key < _len; _key++) {
    all[_key] = arguments[_key];
  }

  all = all && all.length === 1 && Array.isArray(all[0]) ? all[0] : all;

  if (!all || all.length === 0) {
    return function () {
      return Promise.resolve({
        validated: "ok",
        message: null
      });
    };
  }

  return function () {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return new Promise(function (resolve, reject) {
      var resolved = 0;
      var bestCandidate = {
        validated: "ok",
        message: null
      };

      var _loop = function _loop(i) {
        (0, _makePromise.default)(function () {
          return all[i].apply(null, args);
        }).then(function (result) {
          if (resolved !== true) {
            result = (0, _sanitization.sanitizeValidationResult)(result);
            resolved++;

            if (result.validated === "error") {
              resolved = true;
              return reject(result);
            }

            if (!bestCandidate) {
              bestCandidate = result;
            }

            if (result.validated === "hint" && bestCandidate.validated === "ok") {
              bestCandidate = result;
            }

            if (resolved >= all.length) {
              resolved = true;
              return resolve(bestCandidate);
            }
          }
        }).catch(function (error) {
          if (resolved !== true) {
            resolved = true;
            return reject((0, _sanitization.sanitizeValidationResult)(error, true));
          }
        });
      };

      for (var i = 0; i < all.length; i++) {
        _loop(i);
      }
    });
  };
};

var _default = combined;
exports.default = _default;